//************************************************************
//* Motion Guide Example by ATK Solutions 
//* in order for this to work you need to set up a
//* local web hosting http://127.0.0.1/motionguide/play.html
//************************************************************

var canvas = document.getElementById("canvasgame");
var ctx = canvas.getContext("2d");
var images_loaded=0;

var arr_motion = new Array(); // We are using arrays because we can pass by refernce to functions
// arr_motion[0] = x-value, 
// arr_motion[1] = y-value,
// arr_motion[2] = angle,
// arr_motion[3] = count,  
// arr_motion[4] = max_hops

var img_motion = new Image;
var img_motion_x=0;
var img_motion_y=0;
var img_motion_data; 
img_motion.src = "img_motion.png";
img_motion.onload = function(){
	images_loaded++;
	ctx.drawImage(img_motion,0,0,430,430,0,0,430,430);		
	img_motion_data = ctx.getImageData(0,0,430,430);
//  alert(getPixelXY(img_motion_data,254,0));	 
};

//******************** Use the Ball that will go along the line ************************
var img_ball = new Image;
var img_ball_x=50;
var img_ball_y=50;
img_ball.src = "ball.png";
img_ball.onload = function(){
	images_loaded++;
		 
};

setTimeout(preloadloop,10);

 
//**************** Starts the PreLoading ********************
function preloadloop() {
  	if (images_loaded<2) {
  		 setTimeout(preloadloop,50); 
  		 return;
  	}

    if (motion_get_first_point(arr_motion,"R",0,0,430,429,90,-1)==true) {
  		  img_ball_x=arr_motion[0]; 
  		  img_ball_y=arr_motion[1];
        setTimeout(gameloop,50); 
    }
}

//********************* Game Loop ***************************
function gameloop() {
		ctx.clearRect(0, 0, 430, 430);
		ctx.drawImage(img_motion,0,0,430,430,0,0,430,430);	
  	ctx.drawImage(img_ball,0,0,20,20,img_ball_x-10,img_ball_y-10,20,20);		
  
  	if (motion_get_next_point(arr_motion,5)==true) {
  		 img_ball_x=arr_motion[0]; 
  		 img_ball_y=arr_motion[1];
  	} 

    setTimeout(gameloop,25);
}

//************** Initialize the Motion Array and get the starting point *****************
function motion_get_first_point(p_arr,p_dir,p_x,p_y,p_wid,p_hei,p_angle,p_maxsteps) {
var c,d;
//	     180
//        |
//        |
// 270 ---+--- 90
//        |
//        |
//        0


p_arr[0]=0; p_arr[1]=0; p_arr[2]=0; p_arr[3]=0; p_arr[4]=0;

if (p_dir=="T") {
    for (d=p_y;d<p_y+p_hei;d++)
       for (c=p_x;c<p_x+p_wid;c++)	
	       if (getPixelXY(img_motion_data,c,d)[0]!=0) { 
		      p_arr[0]=c; p_arr[1]=d; p_arr[2]=p_angle; p_arr[3]=0; p_arr[4]=p_maxsteps;
			    return true; 
			  }
}

if (p_dir=="L") {
	for (c=p_x;c<p_x+p_wid;c++)	
		for (d=p_y;d<p_y+p_hei;d++)
			if (getPixelXY(img_motion_data,c,d)[0]!=0) { 
				p_arr[0]=c; p_arr[1]=d; p_arr[2]=p_angle; p_arr[3]=0; p_arr[4]=p_maxsteps;
				return true; 
			}
}

if (p_dir=="B") {
    for (d=p_y+p_hei;d>p_y;d--)
       for (c=p_x;c<p_x+p_wid;c++)	
	       if (getPixelXY(img_motion_data,c,d)[0]!=0) { 
		        p_arr[0]=c; p_arr[1]=d; p_arr[2]=p_angle; p_arr[3]=0; p_arr[4]=p_maxsteps;
			      return true; 
		     }
			
}

if (p_dir=="R") {
	for (c=p_x+p_wid;c>p_x;c--)	
		for (d=p_y;d<p_y+p_hei;d++) {
			if (getPixelXY(img_motion_data,c,d)[0]!=0) { 
				  p_arr[0]=c; p_arr[1]=d; p_arr[2]=p_angle; p_arr[3]=0; p_arr[4]=p_maxsteps;
				  return true; 
			}
	 }		
}


return false;
}


//******* Get the next point along the motion curve and set the array to it **************
function motion_get_next_point(p_arr,p_space) {
var c,deg,rad,newx,newy,newx2,newy2,startangle,chkangle;

if (p_arr[3]>=p_arr[4] && p_arr[4]!=-1) return false;

startangle=p_arr[2]; 
startangle=startangle % 360;
	
for (c=0;c<=180;c++) {
		chkangle = startangle + c;
		deg = chkangle * Math.PI/180;
		newx=Math.sin(deg) * p_space + p_arr[0];  
		newy=Math.cos(deg) * p_space + p_arr[1];

		newx=Math.floor(newx+.5); 
		newy=Math.floor(newy+.5);

		if (getPixelXY(img_motion_data,newx,newy)[0]!=0) { //*** Found a Point ***
			   p_arr[0]=newx; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1;  
			   return true; 
		}

		if (getPixelXY(img_motion_data,newx+1,newy)[0]!=0) { //*** Found a Point ***
			   p_arr[0]=newx+1; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1; 
			   return true; 
	  }
			
		chkangle = startangle - c;
		deg = chkangle * Math.PI/180;
		newx=Math.sin(deg) * p_space + p_arr[0];  
		newy=Math.cos(deg) * p_space + p_arr[1];
		
		newx=Math.floor(newx+.5); 
		newy=Math.floor(newy+.5);

		if (getPixelXY(img_motion_data,newx,newy)[0]!=0) { //*** Found a Point ***
			  p_arr[0]=newx; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1; 
			  return true; 
		}
		if (getPixelXY(img_motion_data,newx+1,newy)[0]!=0) { //*** Found a Point ***
			  p_arr[0]=newx+1; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1; 
			  return true; 
	  }			
		if (getPixelXY(img_motion_data,newx,newy+1)[0]!=0) { //*** Found a Point ***
			  p_arr[0]=newx+1; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1; 
			  return true; 
	  }		
		if (getPixelXY(img_motion_data,newx+1,newy+1)[0]!=0) { //*** Found a Point ***
			  p_arr[0]=newx+1; p_arr[1]=newy; p_arr[2]=chkangle; p_arr[3]=p_arr[3]+1; 
			  return true; 
	  }		
} // for (c=0;c<=180;c++) {
	
return false;
} // end  motion_get_next_point



function getPixel(p_imgdata, p_index) {
  var i = p_index*4;
	var d = p_imgdata.data;
  return [d[i],d[i+1],d[i+2],d[i+3]] // returns array [R,G,B,A]
}

function getPixelXY(p_imgdata, x, y) {
  return getPixel(p_imgdata, y*p_imgdata.width+x);
}

